(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "@tsparticles/engine", "./CurvesPathGenerator.js"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.curvesPathName = void 0;
    exports.loadCurvesPath = loadCurvesPath;
    const engine_1 = require("@tsparticles/engine");
    const CurvesPathGenerator_js_1 = require("./CurvesPathGenerator.js");
    exports.curvesPathName = "curvesPathGenerator";
    async function loadCurvesPath(engine, refresh = true) {
        (0, engine_1.assertValidVersion)(engine, "3.7.1");
        await engine.addPathGenerator(exports.curvesPathName, new CurvesPathGenerator_js_1.CurvesPathGenerator(), refresh);
    }
});
